import processing.core.*; import processing.video.*; public class camera extends PMIDlet{// Photoslider
// by Francis Li
// http://www.francisli.com/
//
// Posted May 31, 2006
//
// Hacked by David A. Mellis (June 30, 2006)
// 
// This example demonstrates the use of the Video library to capture images
// on a camera phone. 
//


int CAPTUREMODE = 0;
int DISPLAYMODE = 1;
int mode = CAPTUREMODE;

Capture cap;
PFont font;
PImage img;

public void setup() {
  // set up camera capture from library
  cap = new Capture(this);  
  
  cap.show(0, 0, width, height);
  
  // load and set default phone font for display
  font = loadFont();
  textFont(font);
  
  // no animation loop during capture, since the phone will automatically
  // draw the camera image.
  noLoop();
}

public void destroy() {
  // close the camera object on sketch exit
  cap.close();
}

public void draw() {
  //// set a black background
  background(0);
  
  // In display mode, draw the last captured picture.
  if (mode == DISPLAYMODE) {
    image(img, 0, 0);
    text("Bello", width / 2, 20);
  }
  
  // In capture mode, don't draw anything, since the phone does it for us.
}

public void keyPressed() {
  if (mode == CAPTUREMODE) {
    // capture a frame and load it into a PImage
    byte[] data = cap.read();
    cap.hide();
    img = loadImage(data);
    mode = DISPLAYMODE;
    
    // in display mode, we need to loop through the draw() function.
    loop();
  } else if (mode == DISPLAYMODE) {
    // In display mode, pressing a key goes back to capture mode
    noLoop();
    cap.show(0, 0, width, height);
    mode = CAPTUREMODE;
  }
}
}