import processing.core.*; import processing.phone.*; public class modes extends PMIDlet{/*  30th June 2006. UIAV Venice mobile services workshop. 
    By David Mellis & Vinay Venkatraman
    
    
    
    Images should be placed in the "data" directory of this sketch.
    
    Tested on a Nokia 6630 Phone only 
*/

     // import phone library for fullScreen() function

Phone p;

int MENU_MODE = 0;
int MAP_MODE = 1;
int GAME_MODE = 2;
int TALK_MODE = 3;

int mode = MENU_MODE;

// Variables for menu mode //////////////////////////////////////////////////////////////
int cur_image = 0; // currently selected menu item
String bgfile = "blue.png"; // the file name of the background image.
PImage bgimage; // the actual background image.

// An array of the names of the image files for the menus, in order.
String files[] = { "menu-map.png", "menu-game.png", "menu-talk.png" };

// An array of the actual menu images.
PImage images[];

// Variables for map mode ///////////////////////////////////////////////////////////////
PImage mapimage; 
int x=0;                       // Image initial position_X
int y=0;                       // Image initial position_Y 
int img_width;                 // Image width 
int img_height;                // Image height
int pan_speed = 10;            // Set pan speed ( 8 to 10 is a good speed)
String mapfile = "map.png";   // Select image file

// Variables for game mode //////////////////////////////////////////////////////////////
String gamefile = "game.png";
PImage gameimage;

// Variables for talk mode //////////////////////////////////////////////////////////////
String talkfile = "talk.png";
PImage talkimage;

public void setup()
{
  p = new Phone(this);
  p.fullscreen();              // Go full screen   

  // Setup menu mode ////////////////////////////////////////////////////////////////////
  // Load the background image.
  bgimage = loadImage(bgfile);
  
  // Create an array to hold the slide images (files.length is the
  // length of the files array - that is, the number of slides).
  images = new PImage[files.length];
  
  // Load each of the slide images.
  for (int i = 0; i < files.length; i = i + 1)
    images[i] = loadImage(files[i]);

  // Setup map mode ////////////////////////////////////////////////////////////////////
  mapimage = loadImage(mapfile);

  // Setup game mode ////////////////////////////////////////////////////////////////////
  gameimage = loadImage(gamefile);

  // Setup talk mode ////////////////////////////////////////////////////////////////////
  talkimage = loadImage(talkfile);
}

public void draw()
{
  if (mode == MENU_MODE) {
    // Menu mode ////////////////////////////////////////////////////////////////////////
    // Draw the background image.
    image(bgimage, 0, 0);
  
    // Draw the current slide image.
    image(images[cur_image], 0, 0);  
  } else if (mode == MAP_MODE) {
    // Map mode /////////////////////////////////////////////////////////////////////////
  
    // this is true as long as a key is still held down.
    if(keyPressed)
    { 
      // Make sure this is within the main draw loop to get continous pan on keypress.
      // Otherwise, you would need to press the keys over and over to move.
    
      if(keyCode == DOWN){
        y=y-pan_speed;                // Pan up 
      } else if (keyCode == UP){
        y=y+pan_speed;                 // Pan down
      } 
      else if (keyCode == RIGHT){
        x=x-pan_speed;                 // Pan left 
      }
      else if (keyCode == LEFT) {
        x=x+pan_speed;                 // Pan right  
      }
    
      x = constrain(x,(width-mapimage.width),0);   // Prevent image from panning beyond width
      y = constrain(y,(height-mapimage.height),0); // Prevent image from panning beyond height
    }
  
    image(mapimage, x, y);              // Display image
  } else if (mode == GAME_MODE) {
    // Game mode /////////////////////////////////////////////////////////////////////////
    image(gameimage, 0, 0);  
  } else if (mode == TALK_MODE) {
    // Talk mode /////////////////////////////////////////////////////////////////////////
    image(talkimage, 0, 0);  
  }
}

public void keyPressed()
{
  if (mode == MENU_MODE) {
    // Menu mode ////////////////////////////////////////////////////////////////////////
    if (keyCode == RIGHT || keyCode == DOWN){
      cur_image = cur_image + 1;
    } else if (keyCode == LEFT || keyCode == UP) {
      cur_image = cur_image - 1;
    }

    // Keep the current image within the range of images available (which goes
    // from zero to one less than the number of images available).
    cur_image = constrain(cur_image, 0, images.length - 1);
    
    if (keyCode == FIRE) {
      // Okay, they pressed the select button, so check which menu item they're on in
      // order to decide which mode to jump to.
      if (cur_image == 0)
        mode = MAP_MODE;
      else if (cur_image == 1)
        mode = GAME_MODE;
      else if (cur_image == 2)
        mode = TALK_MODE;
    }
  } else if (mode == MAP_MODE) {
    // Map mode ////////////////////////////////////////////////////////////////////////
    // Center key goes back to menu.
    if (keyCode == FIRE)
      mode = MENU_MODE;
  } else if (mode == GAME_MODE) {
    // Game mode ////////////////////////////////////////////////////////////////////////
    // Center key goes back to menu.
    if (keyCode == FIRE)
      mode = MENU_MODE;
  } else if (mode == TALK_MODE) {
    // Talk mode ////////////////////////////////////////////////////////////////////////
    // Center key goes back to menu.
    if (keyCode == FIRE)
      mode = MENU_MODE;
  }
}
}