/*  30th June 2006. UIAV Venice mobile services workshop. 
    By Vinay Venkatraman & David Mellis 
    Pressing Ok/Confirm will allow you to use the phone's native input method
    Pressing 0 Key will exit the program since softkey by deafult does not appear in fullscreen mode
    Tested on a Nokia 6630 Phone only 
*/

import processing.phone.*;              // import phone library to go full screen

Phone p;
PFont font;                             // Declare font
String render_text="";                    // Set initial text

void setup()
{
  size(176, 208);                       // Set the screen size for Nokia 6630
  p = new Phone(this);                  // Create a new instance of phone
  p.fullscreen();                       // Go full screen 
  
  font = loadFont("Verdana-10.mvlw");   // Load the font file from the data folder
  textFont(font);                       // Use the font for rendering text
}


void keyPressed() 
{
  if (keyCode == FIRE) {
     String user_text = textInput("Name", "", 20);  // Get the string from the device input method
    if(user_text != null){                          // Check to make sure text is not null or will cause an exception
     render_text = user_text; }
   }  
  else if(keyCode == '0') { 
    exit();                                        // Exit the program 
   } 
     
}


void draw() {
  
  fill(255, 255, 255);                         // Change fill colour to white
  rect(0,0,width,height);                      // Fill the screen to wipe off the old text
  text("Press 0 to exit", 15, 180);            // Display exit message
  text("Press Ok to enter your name", 15, 50);
                     
  text(render_text, 15, 100);                 // Render the input text on screen
  
}

